/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.118 by edhill, Wed Feb 9 17:34:19 2005 UTC revision 1.192 by jmc, Wed Apr 22 21:03:52 2009 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 122  EOF Line 130  EOF
130        stop        stop
131        end        end
132  EOF  EOF
133      test -f Makefile  &&  mv -f Makefile Makefile.bak      test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
134      cat <<EOF >> Makefile      cat <<EOF >> $MAKEFILE
135  .SUFFIXES:  .SUFFIXES:
136  .SUFFIXES: .$tfs .F  .SUFFIXES: .$tfs .F
137  .F.$tfs:  .F.$tfs:
# Line 148  EOF Line 156  EOF
156              return              return
157          fi          fi
158      fi      fi
159      rm -f genmake_hello.* Makefile      rm -f genmake_hello.* $MAKEFILE
160      test -f Makefile  &&  mv -f Makefile.bak Makefile      test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
161    
162      #  If we make it here, use the extensions      #  If we make it here, use the extensions
163      FS=$tfs      FS=$tfs
# Line 181  look_for_makedepend()  { Line 189  look_for_makedepend()  {
189      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
190          which makedepend > /dev/null 2>&1          which makedepend > /dev/null 2>&1
191          RV0=$?          RV0=$?
192            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
193            #  echo 'MAKEFILE="'$MAKEFILE'"'
194            cat <<EOF >> $MAKEFILE
195    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196    #
197    #   Some "makedepend" implementations will die if they cannot
198    #   find a Makefile -- so this file is here to gives them an
199    #   empty one to find and parse.
200    EOF
201          cat <<EOF >> genmake_tc.f          cat <<EOF >> genmake_tc.f
202        program test        program test
203        write(*,*) 'test'        write(*,*) 'test'
# Line 189  look_for_makedepend()  { Line 206  look_for_makedepend()  {
206  EOF  EOF
207          makedepend genmake_tc.f > /dev/null 2>&1          makedepend genmake_tc.f > /dev/null 2>&1
208          RV1=$?          RV1=$?
209            test -f $MAKEFILE  &&  rm -f $MAKEFILE
210            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
211          if test "x${RV0}${RV1}" = x00 ; then          if test "x${RV0}${RV1}" = x00 ; then
212              MAKEDEPEND=makedepend              MAKEDEPEND=makedepend
213          else          else
# Line 237  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 271  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 310  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 342  EOF Line 396  EOF
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 516  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
609      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
# Line 523  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -omp | --omp
615              Activate OpenMP code + use Compiler option OMPFLAG
616        -omp=OMPFLAG | --omp=OMPFLAG
617              Activate OpenMP code + use Compiler option OMPFLAG
618    
619        -es | --es | -embed-source | --embed-source
620              Embed a tarball containing the full source code
621              (including the Makefile, etc.) used to build the
622              executable [off by default]
623    
624      -bash NAME      -bash NAME
625            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
626    
# Line 587  EOF Line 685  EOF
685        call tsub( string )        call tsub( string )
686        end        end
687  EOF  EOF
688      $FC $FFLAGS $DEFINES -c genmake_tcomp.$FS >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
689      RETVAL=$?      RETVAL=$?
690      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
691          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 653  void FC_NAMEMANGLE(cloc) ( double *curti Line 751  void FC_NAMEMANGLE(cloc) ( double *curti
751   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
752  }  }
753  EOF  EOF
754      make genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
755        echo $COMM >> genmake_warnings
756        $COMM >> genmake_warnings 2>&1
757      RET_C=$?      RET_C=$?
758      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
759        program hello        program hello
760        Real*8 wtime        REAL*8 wtime
761        external cloc        external cloc
762        call cloc(wtime)        call cloc(wtime)
763        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
764        end program hello        end
765  EOF  EOF
766      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
767        echo $COMM >> genmake_warnings
768        $COMM >> genmake_warnings 2>&1
769      RET_F=$?      RET_F=$?
770      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
771      RETVAL=$?      RETVAL=$?
# Line 675  EOF Line 777  EOF
777  }  }
778    
779    
780    check_HAVE_SIGREG()  {
781        if test ! "x$HAVE_SIGREG" = x ; then
782            return
783        fi
784        get_fortran_c_namemangling
785        cat <<EOF > genmake_tc_1.c
786    $FC_NAMEMANGLE
787    #include <stdlib.h>
788    #include <stdio.h>
789    #include <signal.h>
790    #include <errno.h>
791    #include <ucontext.h>
792    
793    int * ip;
794    
795    static void killhandler(
796        unsigned int sn, siginfo_t  si, struct ucontext *sc )
797    {
798        *ip = *ip + 1;
799        return;
800    }
801    
802    void FC_NAMEMANGLE(sigreg) (int * aip)
803    {
804        struct sigaction s;
805        ip = aip;
806        s.sa_flags = SA_SIGINFO;
807        s.sa_sigaction = (void *)killhandler;
808        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
809            printf("Sigaction returned error = %d\n", errno);
810            exit(0);
811        }
812        return;
813    }
814    EOF
815        COMM="$CC $CFLAGS -c genmake_tc_1.c"
816        echo $COMM >> genmake_warnings
817        $COMM >> genmake_warnings 2>&1
818        RET_C=$?
819        cat <<EOF > genmake_tc_2.$FS
820          program hello
821          integer anint
822          common /iv/ anint
823          external sigreg
824          call sigreg(anint)
825          end
826    EOF
827        echo >> genmake_warnings
828        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
829        cat genmake_tc_2.$FS >> genmake_warnings
830        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
831        echo $COMM >> genmake_warnings
832        $COMM >> genmake_warnings 2>&1
833        RETVAL=$?
834        if test "x$RETVAL" = x0 ; then
835            HAVE_SIGREG=t
836            DEFINES="$DEFINES -DHAVE_SIGREG"
837        fi
838        rm -f genmake_tc*
839    }
840    
841    
842    check_HAVE_SETRLSTK()  {
843        if test "x$HAVE_SETRLSTK" = xt ; then
844            DEFINES="$DEFINES -DHAVE_SETRLSTK"
845            return
846        fi  
847        if test ! "x$HAVE_SETRLSTK" = x ; then
848            return
849        fi
850        get_fortran_c_namemangling
851        cat <<EOF > genmake_tc_1.c
852    $FC_NAMEMANGLE
853    #include <sys/time.h>
854    #include <sys/resource.h>
855    #include <unistd.h>
856    void FC_NAMEMANGLE(setrlstk) ()
857    {
858        struct rlimit rls;
859        rls.rlim_cur = RLIM_INFINITY;
860        rls.rlim_max = RLIM_INFINITY;
861        setrlimit(RLIMIT_STACK, &rls);
862        return;
863    }
864    EOF
865        COMM="$CC $CFLAGS -c genmake_tc_1.c"
866        echo $COMM >> genmake_warnings
867        $COMM >> genmake_warnings 2>&1
868        RET_C=$?
869        cat <<EOF > genmake_tc_2.$FS
870          program hello
871          external setrlstk
872          call setrlstk()
873          end
874    EOF
875        echo >> genmake_warnings
876        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
877        cat genmake_tc_2.$FS >> genmake_warnings
878        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
879        echo $COMM >> genmake_warnings
880        $COMM >> genmake_warnings 2>&1
881        RETVAL=$?
882        if test "x$RETVAL" = x0 ; then
883            HAVE_SETRLSTK=t
884            DEFINES="$DEFINES -DHAVE_SETRLSTK"
885        fi
886        rm -f genmake_tc*
887    }
888    
889    
890  check_HAVE_STAT()  {  check_HAVE_STAT()  {
891      get_fortran_c_namemangling      get_fortran_c_namemangling
892      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
# Line 696  void FC_NAMEMANGLE(tfsize) ( int *nbyte Line 908  void FC_NAMEMANGLE(tfsize) ( int *nbyte
908          *nbyte = -1;          *nbyte = -1;
909  }  }
910  EOF  EOF
911      make genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$CC $CFLAGS -c genmake_tc_1.c"
912        echo $COMM >> genmake_warnings
913        $COMM >> genmake_tc.log 2>&1
914      RET_C=$?      RET_C=$?
915      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
916        program hello        program hello
917        integer nbyte        integer nbyte
918        call tfsize(nbyte)        call tfsize(nbyte)
919        print *," HELLO WORLD", nbyte        print *," HELLO WORLD", nbyte
920        end program hello        end
921  EOF  EOF
922      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_tc.log 2>&1      echo >> genmake_warnings
923      RET_F=$?      echo "running: check_HAVE_STAT()" >> genmake_warnings
924      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      cat genmake_tc_2.$FS >> genmake_warnings
925        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
926        echo $COMM >> genmake_warnings
927        $COMM >> genmake_tc.log 2>&1
928      RETVAL=$?      RETVAL=$?
929      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
930          HAVE_STAT=t          HAVE_STAT=t
# Line 721  check_netcdf_libs()  { Line 938  check_netcdf_libs()  {
938      if test ! "x$SKIP_NETCDF_CHECK" = x ; then      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
939          return          return
940      fi      fi
941      echo "" > genmake_tnc.log      echo >> genmake_warnings
942        echo "running: check_netcdf_libs()" >> genmake_warnings
943      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.F
944        program fgennc        program fgennc
945  #include "netcdf.inc"  #include "netcdf.inc"
# Line 739  EOF Line 957  EOF
957        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
958        end        end
959  EOF  EOF
960      echo "Executing:" > genmake_tnc.log      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
961      echo "  $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS" \      cat genmake_tnc.F >> genmake_tnc.log
962          > genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
963      RET_CPP=f      RET_CPP=f
964      $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
965          &&  RET_CPP=t      echo "$COMM" >> genmake_tnc.log
966        eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
967      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
968          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
969              > genmake_tnc.log              >> genmake_tnc.log
970          echo "    Please check that \$INCLUDES is properly set." \          echo "    Please check that \$INCLUDES is properly set." \
971              > genmake_tnc.log              >> genmake_tnc.log
972      fi      fi
973      echo "Executing:" > genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
974      echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS" > genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
     echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log  
975      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
976          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
977      RET_COMPILE=$?      RET_COMPILE=$?
978        cat genmake_tnc.log >> genmake_warnings
979    
980      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
981      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 769  EOF Line 988  EOF
988          HAVE_NETCDF=t          HAVE_NETCDF=t
989      else      else
990          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
991          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
992            echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
993            echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
994            echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
995            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
996              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
997              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
998          RET_COMPILE=$?          RET_COMPILE=$?
999            cat genmake_tnc.log >> genmake_warnings
1000          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
1001              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
1002              HAVE_NETCDF=t              HAVE_NETCDF=t
1003          else          else
1004            # try again with "-lnetcdff" added to the libs
1005                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
1006                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
1007                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
1008                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
1009                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
1010                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
1011                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
1012                RET_COMPILE=$?
1013              cat genmake_tnc.log >> genmake_warnings              cat genmake_tnc.log >> genmake_warnings
1014                if test "x$RET_COMPILE" = x0 ; then
1015                    LIBS="$LIBS -lnetcdff -lnetcdf"
1016                    HAVE_NETCDF=t
1017                fi
1018          fi          fi
1019      fi      fi
1020      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 804  DEFINES= Line 1041  DEFINES=
1041  PACKAGES=  PACKAGES=
1042  ENABLE=  ENABLE=
1043  DISABLE=  DISABLE=
1044  MAKEFILE=  # MAKEFILE=
1045  #MAKEDEPEND=  # MAKEDEPEND=
1046  PDEPEND=  PDEPEND=
1047  DUMPSTATE=t  DUMPSTATE=t
1048  PDEFAULT=  PDEFAULT=
# Line 813  OPTFILE= Line 1050  OPTFILE=
1050  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1051  FFLAGS=  FFLAGS=
1052  FOPTIM=  FOPTIM=
1053    FEXTRAFLAGS=
1054    USE_EXTENDED_SRC=
1055    EXTENDED_SRC_FLAG=
1056  CFLAGS=  CFLAGS=
1057  KFLAGS1=  KFLAGS1=
1058  KFLAGS2=  KFLAGS2=
# Line 823  NOOPTFILES= Line 1063  NOOPTFILES=
1063  NOOPTFLAGS=  NOOPTFLAGS=
1064  MPI=  MPI=
1065  MPIPATH=  MPIPATH=
1066    OMP=
1067    OMPFLAG=
1068    TS=
1069    PAPIS=
1070    PCLS=
1071    FOOLAD=
1072    PAPI=
1073    PCL=
1074    HPMT=
1075    GSL=
1076    DEVEL=
1077    HAVE_TEST_L=
1078    
1079  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
1080  HAVE_SYSTEM=  HAVE_SYSTEM=
1081  HAVE_FDATE=  HAVE_FDATE=
1082  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1083  HAVE_CLOC=  HAVE_CLOC=
1084    # HAVE_SETRLSTK=
1085  HAVE_STAT=  HAVE_STAT=
1086  HAVE_NETCDF=  HAVE_NETCDF=
1087  HAVE_ETIME=  HAVE_ETIME=
1088    IGNORE_TIME=
1089    
1090  MODS=  MODS=
1091  TOOLSDIR=  TOOLSDIR=
# Line 844  BASH= Line 1098  BASH=
1098  PWD=`pwd`  PWD=`pwd`
1099  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1100  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1101    EMBED_SRC=
1102  THISHOST=`hostname`  THISHOST=`hostname`
1103  THISCWD=`pwd`  THISCWD=`pwd`
1104  THISDATE=`date`  THISDATE=`date`
# Line 877  TAMC_EXTRA= Line 1132  TAMC_EXTRA=
1132    
1133  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1134  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1135  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI OMP DUMPSTATE STANDARDDIRS"
1136    
1137  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1138  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1139  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1140  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1141  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 907  EOF Line 1162  EOF
1162    
1163  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
1164  gm_local="genmake_local"  gm_local="genmake_local"
 for i in . $MODS ; do  
     if test -r $i/$gm_local ; then  
         . $i/$gm_local  
         break  
     fi  
 done  
1165  printf "  getting local config information:  "  printf "  getting local config information:  "
1166  if test -f $gm_local ; then  if test -f $gm_local ; then
1167      echo "using $gm_local"      echo "using $gm_local"
# Line 924  else Line 1173  else
1173  fi  fi
1174    
1175  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
 #OPTIONS=  
 #n=0  
 #for i ; do  
 #   echo "$i  $n"  
 #   setvar="OPTIONS[$n]='$i'"  
 #   #  echo "  $setvar"  
 #   eval "$setvar"  
 #   n=$(( $n + 1 ))  
 #done  
1176  #parse_options  #parse_options
1177  ac_prev=  ac_prev=
1178  for ac_option in "$@" ; do  for ac_option in "$@" ; do
# Line 1057  for ac_option in "$@" ; do Line 1297  for ac_option in "$@" ; do
1297          -noieee | --noieee)          -noieee | --noieee)
1298              IEEE= ;;              IEEE= ;;
1299    
1300            -ts | --ts)
1301                TS=true ;;
1302            -papis | --papis)
1303                PAPIS=true ;;
1304            -pcls | --pcls)
1305                PCLS=true ;;
1306            -foolad | --foolad)
1307                FOOLAD=true ;;
1308            -papi | --papi)
1309                PAPI=true ;;
1310            -pcl | --pcl)
1311                PCL=true ;;
1312            -hpmt | --hpmt)
1313                HPMT=true ;;
1314    
1315            -gsl | --gsl)
1316                GSL=true ;;
1317    
1318            -devel | --devel)
1319                DEVEL=true ;;
1320    
1321          -mpi | --mpi)          -mpi | --mpi)
1322              MPI=true ;;              MPI=true ;;
1323          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
1324              MPIPATH=$ac_optarg              MPIPATH=$ac_optarg
1325              MPI=true ;;              MPI=true ;;
1326                    
1327  #       -jam | --jam)          -omp | --omp)
1328  #           JAM=1 ;;              OMP=true ;;
1329  #       -nojam | --nojam)          -omp=* | --omp=*)
1330  #           JAM=0 ;;              OMPFLAG=$ac_optarg
1331                OMP=true ;;
1332                    
1333          -ds | --ds)          -ds | --ds)
1334              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 1080  for ac_option in "$@" ; do Line 1342  for ac_option in "$@" ; do
1342              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1343          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1344              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1345            
1346            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1347                IGNORE_TIME="-DIGNORE_TIME" ;;
1348    
1349            -es | --es | -embed-source | --embed-source)
1350                EMBED_SRC=t ;;
1351    
1352          -*)          -*)
1353              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 1095  for ac_option in "$@" ; do Line 1363  for ac_option in "$@" ; do
1363            
1364  done  done
1365    
1366    
1367  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1368      echo      echo
1369      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1370      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1371      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1372      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1373      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1374      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1375      echo      echo
1376  fi  fi
1377    
1378  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1379  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1380      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1381      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1382          ROOTDIR=".."          ROOTDIR=".."
1383      else      else
1384          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1135  if test ! -d ${ROOTDIR} ; then Line 1403  if test ! -d ${ROOTDIR} ; then
1403  fi  fi
1404    
1405  #  Find the MITgcm ${THISVER}  #  Find the MITgcm ${THISVER}
1406  if test -f "${ROOTDIR}/doc/tag-index" ; then  version_file="${ROOTDIR}/doc/tag-index"
1407      THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`  if test -f $version_file ; then
1408        THISVER=`grep '^checkpoint' $version_file | head -1`
1409    #-  remove ./BUILD_INFO.h file if older than version_file
1410        if test -f ./BUILD_INFO.h -a ./BUILD_INFO.h -ot $version_file ; then
1411            echo "  remove ./BUILD_INFO.h (older than ${version_file})"
1412            rm -f ./BUILD_INFO.h
1413        fi
1414    fi
1415    
1416    if test "x$MAKEFILE" = x ; then
1417        MAKEFILE="Makefile"
1418  fi  fi
1419    
1420  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
# Line 1168  if test "x$OPTFILE" != xNONE ; then Line 1446  if test "x$OPTFILE" != xNONE ; then
1446      fi      fi
1447  fi  fi
1448    
 #  Check for broken systems that cannot correctly distinguish *.F and *.f files  
 # check_for_broken_Ff  
   
1449  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1450  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1451      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 1198  if test "x${AD_OPTFILE}" != xNONE ; then Line 1473  if test "x${AD_OPTFILE}" != xNONE ; then
1473      fi      fi
1474  fi  fi
1475    
1476    #====================================================================
1477    #  Set default values if not set by the optfile
1478    #
1479  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1480  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1481  if test ! "x$BASH" = x ; then  if test ! "x$BASH" = x ; then
# Line 1274  Error: The command "ln -s" failed -- ple Line 1552  Error: The command "ln -s" failed -- ple
1552  EOF  EOF
1553      exit 1      exit 1
1554  fi  fi
1555    test -L genmake_tlink > /dev/null 2>&1
1556    RETVAL=$?
1557    if test "x$RETVAL" = x0 ; then
1558        HAVE_TEST_L=t
1559    fi
1560  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1561    
1562  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1283  if test ! "x$MPI" = x ; then Line 1566  if test ! "x$MPI" = x ; then
1566        echo "  Turning on MPI cpp macros"        echo "  Turning on MPI cpp macros"
1567        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1568  fi  fi
1569    if test ! "x$OMP" = x ; then
1570          echo "  Add OMPFLAG and turn on OpenMP cpp macros"
1571          FFLAGS="$FFLAGS $OMPFLAG"
1572          F90FLAGS="$F90FLAGS $OMPFLAG"
1573          DEFINES="$DEFINES -DUSE_OMP_THREADING"
1574    fi
1575    
1576    if test ! "x$TS" = x ; then
1577          echo "  Turning on timing per timestep"
1578          if test ! "x$FOOLAD" = x ; then
1579                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1580          else
1581                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1582          fi
1583          PACKAGES="$PACKAGES showflops"
1584    fi
1585    if test ! "x$PAPIS" = x ; then
1586          echo "  Turning on PAPI flop summary per timestep"
1587          echo "  Please make sure PAPIINC, PAPILIB are defined"
1588          if test ! "x$FOOLAD" = x ; then
1589                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1590          else
1591                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1592          fi
1593          INCLUDES="$INCLUDES $PAPIINC"
1594          LIBS="$LIBS $PAPILIB"
1595          PACKAGES="$PACKAGES showflops"
1596    fi
1597    if test ! "x$PCLS" = x ; then
1598          echo "  Turning on PCL counter summary per timestep"
1599          echo "  Please make sure PCLINC, PCLLIB are defined"
1600          if test ! "x$FOOLAD" = x ; then
1601                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1602          else
1603                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1604          fi
1605          INCLUDES="$INCLUDES $PCLINC"
1606          LIBS="$LIBS $PCLLIB"
1607          PACKAGES="$PACKAGES showflops"
1608    fi
1609    if test ! "x$PAPI" = x ; then
1610          if test ! "x$PAPIS" = x ; then
1611              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1612              echo "  Sticking with PAPI flop summary per timestep!"
1613          else
1614              echo "  Turning on performance analysis with PAPI"
1615              echo "  Please make sure PAPIINC, PAPILIB are defined"
1616              DEFINES="$DEFINES -DUSE_PAPI"
1617              INCLUDES="$INCLUDES $PAPIINC"
1618              LIBS="$LIBS $PAPILIB"
1619          fi
1620    fi
1621    if test ! "x$PCL" = x ; then
1622          if test ! "x$PCLS" = x ; then
1623              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1624              echo "  Sticking with PCL flop summary per timestep!"
1625          else
1626              echo "  Turning on performance analysis with PCL"
1627              echo "  Please make sure PCLINC, PCLLIB are defined"
1628              DEFINES="$DEFINES -DUSE_PCL"
1629              INCLUDES="$INCLUDES $PCLINC"
1630              LIBS="$LIBS $PCLLIB"
1631          fi
1632    fi
1633    if test ! "x$HPMT" = x ; then
1634          if test ! "x$PAPI" = x ; then
1635              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1636              echo "  Sticking with PAPI!"
1637          else if test ! "x$PCL" = x ; then
1638              echo "  PCL and the HPM Toolkit cannot co-exist!"
1639              echo "  Sticking with PCL!"
1640          else
1641              echo "  Turning on performance analysis with the HPM Toolkit"
1642              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1643              DEFINES="$DEFINES -DUSE_LIBHPM"
1644              INCLUDES="$INCLUDES $HPMTINC"
1645              LIBS="$LIBS $HPMTLIB"
1646          fi
1647          fi
1648    fi
1649    if test ! "x$GSL" = x ; then
1650          echo "  Turning on use of GSL to control floating point calculations"
1651          echo "  Please make sure GSLINC, GSLLIB are defined"
1652          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1653          INCLUDES="$INCLUDES $GSLINC"
1654          LIBS="$LIBS $GSLLIB"
1655    fi
1656    #- if USE_EXTENDED_SRC is set, add EXTENDED_SRC_FLAG to FFLAGS :
1657    if test ! "x$USE_EXTENDED_SRC" = x ; then
1658          FFLAGS="$FFLAGS $EXTENDED_SRC_FLAG"
1659          F90FIXEDFORMAT="$F90FIXEDFORMAT $EXTENDED_SRC_FLAG"
1660    fi
1661    
1662  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1663  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
# Line 1291  cat > genmake_tcomp.$FS <<EOF Line 1666  cat > genmake_tcomp.$FS <<EOF
1666        call system('echo hi')        call system('echo hi')
1667        end        end
1668  EOF  EOF
1669  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1670  RETVAL=$?  RETVAL=$?
1671  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1672      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1306  rm -f genmake_tcomp* Line 1681  rm -f genmake_tcomp*
1681  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1682  cat > genmake_tcomp.$FS <<EOF  cat > genmake_tcomp.$FS <<EOF
1683        program hello        program hello
1684        CHARACTER(128) string        CHARACTER*(128) string
1685        string = ' '        string = ' '
1686        call fdate( string )        call fdate( string )
1687        print *, string        print *, string
1688        end        end
1689  EOF  EOF
1690  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1691  RETVAL=$?  RETVAL=$?
1692  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1693      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1334  cat > genmake_tcomp.$FS <<EOF Line 1709  cat > genmake_tcomp.$FS <<EOF
1709        print *, tarray        print *, tarray
1710        end        end
1711  EOF  EOF
1712  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1713  RETVAL=$?  RETVAL=$?
1714  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1715      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1352  if test "x$HAVE_CLOC" != x ; then Line 1727  if test "x$HAVE_CLOC" != x ; then
1727      echo "yes"      echo "yes"
1728  else  else
1729      echo "no"      echo "no"
1730        if test "x$EMBED_SRC" = xt ; then
1731            echo "    WARNING: you requested file embedding but it has"
1732            echo "      been disabled since C code cannot be called"
1733            EMBED_SRC=
1734        fi
1735    fi
1736    rm -f genmake_t*
1737    
1738    printf "  Can we unlimit the stack size using $FC...  "
1739    check_HAVE_SETRLSTK
1740    if test "x$HAVE_SETRLSTK" = xt ; then
1741        echo "yes"
1742    else
1743        echo "no"
1744    fi
1745    rm -f genmake_t*
1746    
1747    printf "  Can we register a signal handler using $FC...  "
1748    check_HAVE_SIGREG
1749    if test "x$HAVE_SIGREG" = xt ; then
1750        echo "yes"
1751    else
1752        echo "no"
1753  fi  fi
1754  rm -f genmake_t*  rm -f genmake_t*
1755    
# Line 1371  if test "x$HAVE_NETCDF" != x ; then Line 1769  if test "x$HAVE_NETCDF" != x ; then
1769  else  else
1770      echo "no"      echo "no"
1771  fi  fi
1772    DEFINES="$DEFINES $IGNORE_TIME"
1773    
1774    if test "x$EMBED_SRC" = xt ; then
1775        build_embed_encode
1776    fi
1777    if test "x$EMBED_SRC" = xt ; then
1778        ENABLE="$ENABLE embed_files"
1779    fi
1780    
1781    
1782  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1783  printf "  Adding MODS directories:  "  printf "  Adding MODS directories: "
1784  for d in $MODS ; do  for d in $MODS ; do
1785      if test ! -d $d ; then      if test ! -d $d ; then
1786          echo          echo
1787          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1788          exit 1          exit 1
1789      else      else
1790          printf " $d"          printf "$d "
1791          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1792          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1793      fi      fi
1794  done  done
1795  echo  echo
1796    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1797  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1798      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1799  fi  fi
# Line 1461  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1864  if test -r $ROOTDIR"/eesupp/src/Makefile
1864      fi      fi
1865  fi  fi
1866    
1867  #same for exch2  #same for pkg/exch2 and pkg/regrid
1868  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1869      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1870      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1871      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1872      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1873          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1874      else              rm -f make_${pdir}.errors
1875          echo "Error: problem encountered while building source files in exch2:"          else
1876          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1877          exit 1              cat make_${pdir}.errors 1>&2
1878                exit 1
1879            fi
1880      fi      fi
1881  fi  done
1882    
1883  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1884  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1584  done Line 1989  done
1989  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1990  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1991    
1992  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1993  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1994  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1995  RETVAL=$?  RETVAL=$?
1996  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1619  EOF Line 2024  EOF
2024      fi      fi
2025  fi  fi
2026    
2027    #  Check for package PROFILES: if NetCDF is not available,
2028    #  then delete profiles from the list of available packages.
2029    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2030    RETVAL=$?
2031    if test "x$RETVAL" = x0 ; then
2032        if test "x$HAVE_NETCDF" != xt ; then
2033            cat <<EOF
2034    
2035    *********************************************************************
2036    WARNING: the "profiles" package was enabled but tests failed to
2037      compile NetCDF applications.  Please check that:
2038    
2039      1) NetCDF is correctly installed for this compiler and
2040      2) the LIBS variable (within the "optfile") specifies the correct
2041           NetCDF library to link against.
2042    
2043      Due to this failure, the "profiles" package is now DISABLED.
2044    *********************************************************************
2045    
2046    EOF
2047            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2048            DISABLE="$DISABLE profiles"
2049        fi
2050    fi
2051    
2052  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2053  ck=  ck=
2054  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2055      i=0      i=0
2056      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2057      rtot=$nname      rtot=$nname
2058      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2059    
2060          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2061          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1659  while test "x$ck" != xtt ; do Line 2089  while test "x$ck" != xtt ; do
2089    
2090          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2091          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2092                #echo "   " $pname ": need to add :" $dname
2093              in_dis="f"              in_dis="f"
2094              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2095                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1803  fi Line 2234  fi
2234    
2235  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
2236  #  compiler.  #  compiler.
2237  if test -f ./ad_files ; then  if test -f ./adSrcFiles.tmp ; then
2238      rm -f ./ad_files      rm -f ./adSrcFiles.tmp
2239  fi  fi
2240  echo "  Creating the list of files for the adjoint compiler."  echo "  Creating the list of files for the adjoint compiler."
2241  for i in $SOURCEDIRS ; do  for i in $SOURCEDIRS ; do
2242      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`      list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2243      for j in $list_files ; do      for j in $list_files ; do
2244          cat $i/$j >> ad_files          cat $i/$j >> adSrcFiles.tmp
2245      done      done
2246  done  done
2247    if test ! "x"$FS = "x.f" ; then
2248        cat adSrcFiles.tmp | sed -e "s/\.f/.$FS/g" > adSrcFiles.tmp_f
2249        mv -f adSrcFiles.tmp_f adSrcFiles.tmp
2250    fi
2251    
2252  echo  echo
2253  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1824  for i in $INCLUDEDIRS ; do Line 2258  for i in $INCLUDEDIRS ; do
2258      fi      fi
2259  done  done
2260    
2261    if test ! "x$DIVA" = x ; then
2262        echo "  Creating the pseudo-MPI include directory"
2263        INCLUDES="-I./mpi_headers $INCLUDES"
2264        rm -rf ./mpi_headers
2265        mkdir -p ./mpi_headers
2266    
2267        if test "x$MPIINCLUDEDIR" = x ; then
2268            if test "x$MPIHOME" = x ; then
2269                MPIHOME='/usr'
2270            fi
2271            MPIINCLUDEDIR='$MPIHOME/include'
2272        fi
2273        
2274        if test -r $MPIINCLUDEDIR/mpif.h ; then
2275            for i in $MPI_HEADER_FILES; do
2276                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2277            done
2278    
2279            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2280        else
2281            echo " We cannot create a copy of mpif.h!"
2282    #       exit -1
2283        fi
2284    fi
2285    
2286  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2287  rm -rf .links.tmp  rm -rf .links.tmp
2288  mkdir .links.tmp  mkdir .links.tmp
2289    touch .links.tmp/foo
2290    if test ! -r ".links.tmp/foo" ; then
2291        echo
2292        echo "ERROR : something is wrong with your directory permissions or"
2293        echo "   your user file-creation mask (\"umask\") since creating a"
2294        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2295        echo "   not working.  Please try setting your umask to something"
2296        echo "   sane such as:"
2297        echo
2298        echo "      umask 0002"
2299        echo
2300        echo "   and please verify that you have the proper permissions for"
2301        echo "   creating sub-directories and then reading files created"
2302        echo "   within them."
2303        echo
2304        exit 1
2305    fi
2306    rm -f .links.tmp/foo
2307    
2308    if test "x$OPENAD" != x ; then
2309        OAD_DONT_COMPILE="/dev/null"
2310        OAD_DONT_TRANSFORM="/dev/null"
2311        OAD_KEEP_ORIGINAL="/dev/null"
2312        OAD_CB2M_FILES="/dev/null"
2313        echo "  looking for dontCompile file:  "
2314        for i in "." $MODS ; do
2315            if test -r $i"/dontCompile" ; then
2316                OAD_DONT_COMPILE=$i"/dontCompile"
2317                echo "     found $OAD_DONT_COMPILE"
2318                break
2319            fi
2320        done
2321        echo "  looking for dontTransform file:  "
2322        for i in "." $MODS ; do
2323            if test -r $i"/dontTransform" ; then
2324                OAD_DONT_TRANSFORM=$i"/dontTransform"
2325                echo "     found $OAD_DONT_TRANSFORM"
2326                break
2327            fi
2328        done
2329        echo "  looking for keepOriginal file:  "
2330        for i in "." $MODS ; do
2331            if test -r $i"/keepOriginal" ; then
2332                OAD_KEEP_ORIGINAL=$i"/keepOriginal"
2333                echo "     found $OAD_KEEP_ORIGINAL"
2334                break
2335            fi
2336        done
2337        echo "  looking for cb2mFiles:  "
2338        for i in "." $MODS ; do
2339            if test -r $i"/cb2mFiles" ; then
2340                OAD_CB2M_FILES=$i"/cb2mFiles"
2341                echo "     found $OAD_CB2M_FILES"
2342                break
2343            fi
2344        done
2345        echo "   OpenAD exceptions:  "
2346    fi
2347    
2348  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2349  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2350  printf 'SRCFILES = '    > srclist.inc  printf 'F77_SRC_FILES = ' > F77srclist.tmp
2351  printf 'CSRCFILES = '   > csrclist.inc  printf 'NON_AD_F77_SRC_FILES = ' > nonADF77srclist.tmp
2352  printf 'F90SRCFILES = ' > f90srclist.inc  printf 'C_SRC_FILES = '   > csrclist.tmp
2353  printf 'HEADERFILES = ' > hlist.inc  printf 'F90_SRC_FILES = ' > F90srclist.tmp
2354  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'H_SRC_FILES = '   > hsrclist.tmp
2355    printf 'AD_FLOW_FILES = ' > ad_flow_files.tmp
2356  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2357  for d in $alldirs ; do  for d in $alldirs ; do
2358      deplist=      deplist=
2359      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2360      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2361        if test "x$OPENAD" != x ; then
2362            sfiles=`( echo $sfiles | grep -v _cb2m\. )`
2363        fi
2364      for sf in $sfiles ; do      for sf in $sfiles ; do
2365          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2366              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2367                    ignore_f=f
2368                  case $d/$sf in                  case $d/$sf in
2369                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2370                            ignore_f=t
2371                          ;;                          ;;
2372                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2373                            ignore_f=t
2374                          ;;                          ;;
2375                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2376                            ignore_f=t
2377                          ;;                          ;;
2378                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2379                            ignore_f=t
2380                            ;;
2381                      ./EMBEDDED_FILES.h)
2382                            ignore_f=t
2383                          ;;                          ;;
2384                    *)                    *)
2385                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
2386                          deplist="$deplist $sf"                          #  ignore all soft-links
2387                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2388                                ignore_f=t
2389                            else
2390                                touch .links.tmp/$sf
2391                                deplist="$deplist $sf"
2392                            fi
2393                          ;;                          ;;
2394                  esac                  esac
2395                  extn=`echo $sf | $AWK -F. '{print $NF}'`                  if test "x$ignore_f" = xf ; then
2396                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2397                      F)                      case $extn in
2398                          echo    " \\"  >> srclist.inc                        F)
2399                          printf " $sf" >> srclist.inc                          echo    " \\"  >> F77srclist.tmp
2400                            printf " $sf" >> F77srclist.tmp
2401                            if test "x$OPENAD" != x ; then
2402                                basename=${sf%%.F}
2403                                isAD=`egrep ^$basename.f'[  ]*' adSrcFiles.tmp`
2404                                if test -z "$isAD" ; then
2405                                    toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE}`
2406                                    if test -z "$toBeIgnored" ; then
2407                                        echo    " \\"  >> nonADF77srclist.tmp
2408                                        printf " $sf" >> nonADF77srclist.tmp
2409                                    else
2410                                        echo "    not to be compiled   :  $sf"
2411                                    fi
2412                                else # file is initially listed as an AD file we want to exclude it
2413                                     # or we want to retain the untransformed version
2414                                    notToBeTransformed=`egrep ^$basename'[      ]*' ${OAD_DONT_TRANSFORM}`
2415                                    untransformedVersionToBeKept=`egrep ^$basename'[      ]*' ${OAD_KEEP_ORIGINAL}`
2416                                    if test -n "$notToBeTransformed"; then
2417                                        echo "    not to be transformed:  $sf"
2418                                    fi
2419                                    if test -n "$untransformedVersionToBeKept" ; then
2420                                        echo "    original to be kept  :  $sf"
2421                                    fi    
2422                                    if test -n "$notToBeTransformed" -o -n "$untransformedVersionToBeKept" ; then
2423                                        echo    " \\"  >> nonADF77srclist.tmp
2424                                        printf " $sf" >> nonADF77srclist.tmp
2425                                    fi
2426                                fi
2427                            fi
2428                          ;;                          ;;
2429                      F90)                      F90)
2430                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> F90srclist.tmp
2431                          printf " $sf" >> f90srclist.inc                          printf " $sf" >> F90srclist.tmp
2432                          ;;                          ;;
2433                      c)                      c)
2434                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.tmp
2435                          printf " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.tmp
2436                          ;;                          ;;
2437                      h)                      h)
2438                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hsrclist.tmp
2439                          printf " $sf" >> hlist.inc                          printf " $sf" >> hsrclist.tmp
2440                          ;;                          ;;
2441                      flow)                      flow)
2442                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.tmp
2443                          printf " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.tmp
2444                          ;;                          ;;
2445                  esac                     esac
2446                    fi
2447              fi              fi
2448          fi          fi
2449      done      done
2450      if test "x$deplist" != x ; then      if test "x$deplist" != x ; then
2451          echo "" >> srclinks.tmp        if test "$d" != "." ; then
2452            echo "" >> srclinks.tmp
2453          echo "#  These files are linked from $d" >> srclinks.tmp          echo "#  These files are linked from $d" >> srclinks.tmp
2454          echo "$deplist :" >> srclinks.tmp          echo "$deplist :" >> srclinks.tmp
2455          printf "\t\$(LN) %s/\$@ \$@\n" $d >> srclinks.tmp  # We need to make sure that the link isn't already there.
2456    # This may happen when make thinks that a header file has to be "remade"
2457    # because a module it depends on has changed.  In this case we do nothing.
2458            printf "\tif [ ! -L \$@ ]; then \$(LN) %s/\$@ \$@; fi\n" $d >> srclinks.tmp
2459          fi
2460      fi      fi
2461  done  done
2462  rm -rf .links.tmp  rm -rf .links.tmp
2463  echo "" >> srclist.inc  echo "" >> F77srclist.tmp
2464  echo "" >> csrclist.inc  echo "" >> nonADF77srclist.tmp
2465  echo "" >> f90srclist.inc  echo "" >> csrclist.tmp
2466  echo "" >> hlist.inc  echo "" >> F90srclist.tmp
2467  echo "" >> ad_flow_files.inc  echo "" >> hsrclist.tmp
2468    echo "" >> ad_flow_files.tmp
2469    
2470    CMDLINE=$0
2471    for xx in "$@" ; do nw=`echo $xx | wc -w`
2472        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
2473                            else CMDLINE="$CMDLINE '$xx'" ; fi
2474    done
2475    
2476  if test -f $MAKEFILE ; then  if test -f $MAKEFILE ; then
2477      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 1905  echo "#    $MACHINE" >> $MAKEFILE Line 2482  echo "#    $MACHINE" >> $MAKEFILE
2482  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
2483  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
2484  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
2485  echo "#    $0 $G2ARGS" >> $MAKEFILE  echo "#    $CMDLINE"  >> $MAKEFILE
2486  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
2487  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2488    
# Line 1954  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2531  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2531    
2532  # These files are created by Makefile  # These files are created by Makefile
2533  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2534  EOF  EOF
2535    
2536  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2537        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2538    else
2539        echo "EMBEDDED_FILES = " >>$MAKEFILE
2540    fi
2541    
2542  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2543  # Unix ln (link)  # Unix ln (link)
2544  LN = ${LN}  LN = ${LN}
# Line 1985  INCLUDES = ${INCLUDES} Line 2565  INCLUDES = ${INCLUDES}
2565  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2566  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2567  # Optim./debug for FC  # Optim./debug for FC
2568  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2569  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2570  # Optim./debug for FC  # Optim./debug for FC
2571  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
2572  F90OPTIM = ${F90OPTIM}  F90OPTIM = ${F90OPTIM}
2573    F90FIXEDFORMAT = ${F90FIXEDFORMAT}
2574  # Flags for CC  # Flags for CC
2575  CFLAGS = ${CFLAGS}  CFLAGS = ${CFLAGS}
2576  # Files that should not be optimized  # Files that should not be optimized
# Line 2002  MAKEFILE=${MAKEFILE} Line 2583  MAKEFILE=${MAKEFILE}
2583    
2584  EOF  EOF
2585    
2586  cat srclist.inc       >> $MAKEFILE  cat F77srclist.tmp      >> $MAKEFILE
2587  cat csrclist.inc      >> $MAKEFILE  cat nonADF77srclist.tmp >> $MAKEFILE
2588  cat f90srclist.inc    >> $MAKEFILE  cat csrclist.tmp        >> $MAKEFILE
2589  cat hlist.inc         >> $MAKEFILE  cat F90srclist.tmp      >> $MAKEFILE
2590  cat ad_flow_files.inc >> $MAKEFILE  cat hsrclist.tmp        >> $MAKEFILE
2591    cat ad_flow_files.tmp   >> $MAKEFILE
2592    
2593    rm -f F77srclist.tmp nonADF77srclist.tmp csrclist.tmp F90srclist.tmp hsrclist.tmp ad_flow_files.tmp
2594    
2595  echo >> $MAKEFILE  echo >> $MAKEFILE
2596  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  
2597  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  # add definitions for preprocessed sources
2598  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  # and note that not all systems allow case sensitive extensions
2599    # hence the $FS and $FS90 here.
2600    # for fixed format f90 files we use ff90 or FF90 resp
2601    # but these are not expected to be the original source files
2602    
2603    echo 'F77_PP_SRC_FILES = $(F77_SRC_FILES:.F=.'$FS')'      >> $MAKEFILE
2604    echo 'F90_PP_SRC_FILES = $(F90_SRC_FILES:.F90=.'$FS90')' >> $MAKEFILE
2605    echo 'OBJFILES= $(F77_SRC_FILES:.F=.o) $(C_SRC_FILES:.c=.o) $(F90_SRC_FILES:.F90=.o)' >> $MAKEFILE
2606    echo 'FLOFILES =  $(AD_FLOW_FILES:.flow=.flowdir)' >> $MAKEFILE
2607  echo >> $MAKEFILE  echo >> $MAKEFILE
2608  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
2609  echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE  echo '.SUFFIXES: .o .'$FS' .p .F .c .f'$FS90' .'$FS90' .FF90 .F90 .flowdir .flow' >> $MAKEFILE
 rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  
 rm -f ad_flow_files.inc  
2610    
2611  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2612    
2613  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2614  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2615          @echo Creating \$@ ...          @echo Creating \$@ ...
2616          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2617  depend:  depend:
2618          @make links          @make links
2619          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2620          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2621          -rm -f makedepend.out          -rm -f makedepend.out
2622    
2623  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  lib: libmitgcmuv.a
2624    
2625    libmitgcmuv.a: \$(OBJFILES)
2626            ar rcv libmitgcmuv.a \$(OBJFILES)
2627            ar d   libmitgcmuv.a main.o
2628    
2629  small_f: \$(F77FILES) \$(F90FILES)  links: \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(SPECIAL_FILES)
2630    
2631    small_f: \$(F77_PP_SRC_FILES) \$(F90_PP_SRC_FILES)
2632    
2633  output.txt: \$(EXECUTABLE)  output.txt: \$(EXECUTABLE)
2634          @printf 'running ... '          @printf 'running ... '
2635          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2636    
2637  clean:  clean:
2638          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2639            -rm -rf *.o
2640            -rm -rf *.$FS *.flowdir
2641            -rm -rf *.f$FS90 *_mod.h *_mod.F90 *.FF90 *.mod-whirl ad_input*
2642            -rm -rf temp.sed
2643  Clean:  Clean:
2644          @make clean          @make clean
2645          @make cleanlinks          @make cleanlinks
2646          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2647          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log f90mkdepend.log *.bak
2648            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2649  CLEAN:  CLEAN:
2650          @make Clean          @make Clean
2651          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2652          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2653          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2654          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2655            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2656            -rm -rf mnc_test_*
2657    
2658  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2659  makefile:  makefile:
# Line 2057  makefile: Line 2661  makefile:
2661  cleanlinks:  cleanlinks:
2662          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2663    
2664  # Special targets (SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are created by make
2665  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2666          @echo Creating \$@ ...          @echo Creating \$@ ...
2667          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
# Line 2077  test ! "x$THISUSER" = x && echo "      -echo Line 2681  test ! "x$THISUSER" = x && echo "      -echo
2681  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2682  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2683    
2684    if test "x$EMBED_SRC" = xt ; then
2685        cat >>$MAKEFILE <<EOF
2686    
2687    decode_files.o : EMBEDDED_FILES.h
2688    
2689    ##  \$(F77_PP_SRC_FILES)
2690    all_fF.tar.gz : \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2691            @echo Creating \$@ ...
2692            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2693            -rm -f all_fF.tar.gz
2694            -gzip all_fF.tar
2695    
2696    EMBEDDED_FILES.h : all_fF.tar.gz
2697            @echo Creating \$@ ...
2698            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2699    
2700    EOF
2701    fi
2702    
2703  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2704    
2705  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2090  cat >>$MAKEFILE <<EOF Line 2713  cat >>$MAKEFILE <<EOF
2713          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2714  .F90.$FS90:  .F90.$FS90:
2715          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2716    .FF90.f$FS90:
2717            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2718  .$FS90.o:  .$FS90.o:
2719          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2720    .f$FS90.o:
2721            cp \$< \$(basename  \$<).f90
2722            \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$(F90FIXEDFORMAT) \$(basename  \$<).f90
2723  .c.o:  .c.o:
2724          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2725    .flow.flowdir:
2726            \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2727    
2728  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2729  .F.p:  .F.p:
# Line 2101  cat >>$MAKEFILE <<EOF Line 2731  cat >>$MAKEFILE <<EOF
2731  .p.$FS:  .p.$FS:
2732          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2733    
2734    EOF
2735    
2736  #=========================================  #=========================================
2737  #===  Automatic Differentiation Rules  ===  #===  Automatic Differentiation Rules  ===
2738    #===  for TAMC/TAF  ======================
2739    
2740    if test "x$OPENAD" = x ; then
2741    
2742    cat >>$MAKEFILE <<EOF
2743    
2744  TAMC           = ${TAMC}  TAMC           = ${TAMC}
2745  TAF            = ${TAF}  TAF            = ${TAF}
# Line 2117  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2754  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2754  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2755  for i in $ad_vars ; do  for i in $ad_vars ; do
2756      name=$i      name=$i
2757      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2758      eval $t1      eval $t1
2759      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2760      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2761  done  done
2762    
2763  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2764  echo >> $MAKEFILE  echo >> $MAKEFILE
2765  printf "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2766  AD_FILES=`cat ad_files`  AD_FILES=`cat adSrcFiles.tmp`
2767  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2768      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2769      printf " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2770  done  done
2771  echo >> $MAKEFILE  echo >> $MAKEFILE
2772  rm -f ad_files  rm -f adSrcFiles.tmp
2773    
2774  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2775    
2776  # ... AD ...  # ... AD ...
2777  adall: ad_taf  adall: \$(EXE_AD)
2778  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2779  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2780    
2781  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES) \$(AD_FLOW_FILES)
2782          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2783          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2784          -rm -f ad_config.template          -rm -f ad_config.template
2785          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2786          @make \$(AD_FLOW_FILES)          @make \$(FLOFILES)
2787          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(FLOFILES) \$(AD_FILES) > ad_input_code.$FS
2788    
2789  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2790          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2791          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          ls -l ad_input_code_ad.$FS
2792            cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2793    
2794  adtafonly:  adtafonly:
2795          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2796          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          ls -l ad_input_code_ad.$FS
2797            cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2798  ad_taf: ad_taf_output.o \$(OBJFILES)  
2799          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2800            \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2801  ad_tamc_output.f: ad_input_code.f  
2802          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2803          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2804            cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2805    
2806  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2807          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 2175  adtrick: Line 2814  adtrick:
2814    
2815  # ... FTL ...  # ... FTL ...
2816  ftlall: ftl_taf  ftlall: ftl_taf
2817  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2818  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2819    
2820  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2821          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2822          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2823          -rm -f ftl_config.template          -rm -f ftl_config.template
2824          @make \$(F77FILES)          @make \$(F77_PP_SRC_FILES)
2825          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2826          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2827    
2828  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2829          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2830          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          ls -l ftl_input_code_ftl.$FS
2831            cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2832    
2833  ftltafonly:  ftltafonly:
2834          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2835          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          ls -l ftl_input_code_ftl.$FS
2836            cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2837    
2838  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2839          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2840    
2841  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2842          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2843          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2844    
2845  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2846          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2847    
2848    
2849  # ... SVD ...  # ... SVD ...
2850  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2851          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2852          @echo "--->>> Do make svdall afterwards to compile. <<<---"          @echo "--->>> Do make svdall afterwards to compile. <<<---"
2853  svdall: svd_touch svd_taf  svdall: svd_touch svd_taf
# Line 2222  svd_touch: Line 2863  svd_touch:
2863          @echo "--->>> Only COMPILE svd code! <<<---"          @echo "--->>> Only COMPILE svd code! <<<---"
2864          @echo "--->>> Assumes you previously <<<---"          @echo "--->>> Assumes you previously <<<---"
2865          @echo "--->>> did make svdtaf        <<<---"          @echo "--->>> did make svdtaf        <<<---"
2866          touch ad_taf_output.f ftl_taf_output.f          touch ad_taf_output.$FS ftl_taf_output.$FS
2867          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.f          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2868          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.f          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2869          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2870          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2871          -rm -f ftl_config.template          -rm -f ftl_config.template
2872    
2873  #=========================================  EOF
2874    
2875    fi
2876    
2877    #===  for OpenAD  ========================
2878    
2879    if test "x$OPENAD" != x ; then
2880    
2881    # ============ begin OpenAD specific section ==============
2882    
2883    cat >>$MAKEFILE <<EOF
2884    
2885    # all the source files linked from the various locations:
2886    ALL_LINKED_FILES= \
2887    \$(F77_SRC_FILES) \
2888    \$(C_SRC_FILES) \
2889    \$(H_SRC_FILES) \
2890    \$(F90_SRC_FILES) \
2891    \$(SPECIAL_FILES)
2892    
2893    ifndef OPENADROOT
2894      \$(error "Error:  environment variable OPENADROOT not defined!")
2895    endif
2896    
2897    ifndef XAIFSCHEMAROOT
2898      \$(error "Error:  environment variable XAIFSCHEMAROOT not defined!")
2899    endif
2900    
2901    ifndef XAIFBOOSTERROOT
2902      \$(error "Error:  environment variable XAIFBOOSTERROOT not defined!")
2903    endif
2904    
2905  EOF  EOF
2906    
2907    echo "  Add the source list for common block to module conversion "
2908    echo >> $MAKEFILE
2909    printf "CB2M_F90_SRC_NAMES = " >> $MAKEFILE
2910    for i in `cat ${OAD_CB2M_FILES}` ; do
2911      echo    " \\" >> $MAKEFILE
2912      printf " $i" >> $MAKEFILE
2913    done
2914    echo >> $MAKEFILE
2915    
2916    echo "  Add the source list for AD code generation"
2917    echo >> $MAKEFILE
2918    printf "AD_FILES = " >> $MAKEFILE
2919    for i in `cat ${OAD_CB2M_FILES}` ; do
2920      echo    " \\" >> $MAKEFILE
2921      printf " ${i}_mod.f$FS90" >> $MAKEFILE
2922    done
2923    AD_FILES=`cat adSrcFiles.tmp`
2924    for i in $AD_FILES ; do
2925      basename=${i%%.f}
2926      toBeIgnored=`egrep ^$basename'[      ]*' ${OAD_DONT_COMPILE} ${OAD_DONT_TRANSFORM}`
2927      if test -z "$toBeIgnored" ; then
2928        echo    " \\" >> $MAKEFILE
2929        printf " $i" >> $MAKEFILE
2930      fi
2931    done
2932    echo >> $MAKEFILE
2933    rm -f adSrcFiles.tmp
2934    
2935    cat >>$MAKEFILE <<EOF
2936    
2937    adAll: \$(EXE_AD)
2938    .PHONY: adAll
2939    
2940    CB2M_F90_PP_SRC_FILES=\$(addsuffix _mod.f$FS90, \$(CB2M_F90_SRC_NAMES))
2941    
2942    .PRECIOUS: \$(CB2M_F90_PP_SRC_FILES) \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90)
2943    
2944    .PHONY: adDepend
2945    adDepend: \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(addsuffix _mod.FF90, \$(CB2M_F90_SRC_NAMES)) \$(F77_SRC_FILES:.F=_cb2m.FF90)
2946            \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2947            \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2948            -rm -f makedepend.out
2949    
2950    OPENAD_SUPPORT_F90_SRC_FILES = \
2951    w2f__types.F90 \
2952    OAD_active.F90 \
2953    OAD_cp.F90 \
2954    OAD_rev.F90 \
2955    OAD_tape.F90        
2956    
2957    OPENAD_SUPPORT_C_SRC_FILES = \
2958    iaddr.c \
2959    timeRatio.c
2960    
2961    f95_test_mods.f90: \$(OPENAD_SUPPORT_F90_SRC_FILES:F90=$FS90)
2962            cat \$^ > \$@
2963    
2964    f95_test.f90: all_mods.xb.x2w.w2f.pp.f$FS90 \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90) ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2965            cat \$^ > \$@
2966    
2967    f95_test.out: f95_test_mods.f90 f95_test.f90
2968            f95 -fixed -w=unused -maxcontin=132 -c f95_test_mods.f90 > \$@ 2>&1
2969            f95 -fixed -w=unused -maxcontin=132 -c -fixed f95_test.f90 >> \$@ 2>&1
2970    
2971    AD_OBJ_FILES=\$(OPENAD_SUPPORT_F90_SRC_FILES:.F90=.o) \$(OPENAD_SUPPORT_C_SRC_FILES:.c=.o) all_mods.xb.x2w.w2f.pp.o  ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.o \$(NON_AD_F77_SRC_FILES:.F=_cb2m.o) \$(C_SRC_FILES:.c=.o) \$(F90_SRC_FILES:.F90=.o)
2972    
2973    \$(EXE_AD): \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(AD_OBJ_FILES)
2974            @echo Creating \$@ ...
2975            \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(AD_OBJ_FILES) \$(LIBS)
2976    
2977    # makefile debug rule
2978    openad: ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2979    .PHONY: openad
2980    
2981    # create the module files
2982    %_mod.FF90 : %.h ../OAD_support/cb2mGetModules.csh ../OAD_support/cb2mGetModules.awk
2983            ../OAD_support/cb2mGetModules.csh $< ../OAD_support/cb2mGetModules.awk
2984    
2985    # create the header files
2986    %_mod.h : %.h ../OAD_support/cb2mGetHeaders.csh ../OAD_support/cb2mGetHeaders.awk
2987            ../OAD_support/cb2mGetHeaders.csh $< ../OAD_support/cb2mGetHeaders.awk \$(CB2M_F90_SRC_NAMES)
2988    
2989    # change everybody else to use the new module files:
2990    %_cb2m.FF90 : %.F ../OAD_support/cb2mUseModules.bash
2991            ../OAD_support/cb2mUseModules.bash $< ${MPI}
2992    
2993    # makefile debug rule
2994    small_f: \$(CB2M_F90_PP_SRC_FILES)
2995    .PHONY: small_f
2996    
2997    ad_output.txt: \$(EXE_AD)
2998            @printf 'linking data files ... '
2999            \$(LN) -f ../input_ad/data* ../input_ad/eedata .
3000            \$(LN) -f ../../global_ocean.90x40x15/input/*.bin .
3001            @printf 'running ... '
3002            @./\$(EXE_AD) > \$@
3003    
3004    CB2M_AD_FILES=\$(AD_FILES:.f=_cb2m.f$FS90)
3005    ad_input_code.f$FS90: ../OAD_support/maxMinDefs.f \$(CB2M_AD_FILES)
3006            cat \$^ > \$@
3007    
3008    # strip all comments and blanks to reduce
3009    # the file size in order to reduce perl's memory requirements
3010    ad_input_code_sf.f$FS90 : ad_input_code.f$FS90
3011            cat \$^ | sed -f ../OAD_support/strip.sed | sed -f ../OAD_support/stop2print.sed > \$@
3012    
3013    # mfef90 preprocessing
3014    # expand statement functions
3015    # expose mfef90 specific substring handling
3016    # add the w2f__types module
3017    ad_input_code_sf.w2f.f$FS90: ad_input_code_sf.f$FS90 mfef90 whirl2f whirl2f_be w2f__types.f90
3018            ./mfef90 -r8 -z -F -N132 \$<
3019            mv \$<.B \$(basename \$<).B
3020            ./whirl2f -openad \$(basename \$<).B
3021            cat w2f__types.f90 \$(basename \$<).w2f.f > \$@
3022    
3023    # canonicalizer
3024    ad_input_code_sf.w2f.pre.f$FS90: ad_input_code_sf.w2f.f$FS90 preProcess.py
3025            ./preProcess.py -H -S \$< -o \$@
3026    
3027    # F -> WHIRL
3028    # note that the canonicalized version cuts off at col 72
3029    # doing this also for string constants which is ok as long
3030    # as we are in fixed mode and cut of exactly there.
3031    # Otherwise mfef90 patches in spaces to fill up to 72 (or 132)
3032    # characters respectively.
3033    ad_input_code_sf.w2f.pre.B: ad_input_code_sf.w2f.pre.f$FS90 mfef90
3034            ./mfef90 -r8 -z -F \$<
3035            mv \$<.B \$@
3036    
3037    # WHIRL -> XAIF
3038    ad_input_code_sf.w2f.pre.xaif : ad_input_code_sf.w2f.pre.B whirl2xaif
3039            ./whirl2xaif -s -n --debug 1 -o \$@ \$<
3040    
3041    # XAIF -> XAIF'
3042    ad_input_code_sf.w2f.pre.xb.xaif : ad_input_code_sf.w2f.pre.xaif xaif.xsd xaif_base.xsd xaif_inlinable_intrinsics.xsd xaif_derivative_propagator.xsd xaif_output.xsd oadDriver
3043            ./oadDriver -f -t forward_step -i \$< -c \${XAIFSCHEMAROOT}/schema/examples/inlinable_intrinsics.xaif -o \$@ -I -r
3044    
3045    # XAIF' -> WHIRL'
3046    ad_input_code_sf.w2f.pre.xb.x2w.B : ad_input_code_sf.w2f.pre.xb.xaif xaif2whirl
3047            ./xaif2whirl --debug 1 --structured ad_input_code_sf.w2f.pre.B \$<
3048    
3049    # WHIRL' -> F'
3050    ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.B whirl2f whirl2f_be
3051            ./whirl2f -FLIST:ftn_file=\$@ -openad \$<
3052    
3053    # insert template directives
3054    ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90 ../OAD_support/insertTemplateDir.bash
3055            ../OAD_support/insertTemplateDir.bash \$< \$@
3056    
3057    PPEXTRAS=\$(wildcard ../OAD_support/ad_template.*.F) ../OAD_support/ad_inline.F
3058    # postprocess F'
3059    ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90 postProcess.py \$(PPEXTRAS:.F=.f)
3060            ./postProcess.py -m r -i ../OAD_support/ad_inline.f -o \$@ \$<
3061    
3062    # extract all transformed modules
3063    all_mods.xb.x2w.w2f.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3064            cat \$< | sed -n '/MODULE /,/END MODULE/p' > \$@
3065    
3066    # remove the transformed globals module from the
3067    # transformed ad_input_code file
3068    # and remove for now the duplicate variables
3069    # and fix 2 data statements
3070    ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3071            cat \$< | sed '/MODULE /,/END MODULE/d' | sed '/^      INTEGER(w2f__i4) DOLOOP_UB/d' > \$@
3072    
3073    # setup some links
3074    %.xsd:
3075            \$(LN) \${XAIFSCHEMAROOT}/schema/\$@ .
3076    
3077    mfef90:
3078            \$(LN) \${OPEN64ROOT}/crayf90/sgi/mfef90 .
3079    
3080    # link the support files:
3081    \$(OPENAD_SUPPORT_F90_SRC_FILES) \$(OPENAD_SUPPORT_C_SRC_FILES):
3082            \$(LN) ../OAD_support/\$@ .
3083    
3084    whirl2xaif xaif2whirl:
3085            \$(LN) \${OPENADFORTTK}/bin/\$@ .
3086    
3087    preProcess.py postProcess.py:
3088            \$(LN) \${OPENADFORTTK_BASE}/tools/SourceProcessing/\$@ .
3089    
3090    whirl2f whirl2f_be:
3091            \$(LN) \${OPEN64ROOT}/whirl2f/\$@ .
3092    
3093    oadDriver:
3094            \$(LN) \${XAIFBOOSTERROOT}/xaifBooster/algorithms/BasicBlockPreaccumulationReverse/driver/oadDriver \$@
3095    
3096    # ============ end OpenAD specific section ==============
3097    
3098    EOF
3099    
3100    fi
3101    
3102    #=========================================
3103    
3104  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
3105      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE      printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
3106  fi  fi

Legend:
Removed from v.1.118  
changed lines
  Added in v.1.192

  ViewVC Help
Powered by ViewVC 1.1.22